﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=6.01
@EndOfDesignText@
Sub Class_Globals
	Type PointApi(X As Double, Y As Double)
	Private fx As JFX
	Private TxtCapcha As String
	Private imgName As String
	Private Grid As Boolean
	Private Lines As Boolean
	Private wdt = 140.0 As Double
	Private hgt = 100.0 As  Double
	Private cv As Canvas
End Sub

'Inicializa o objeto. Você pode adicionar parâmetros a este método, se necessário.
Public Sub Initialize(Tx As String, imNm As String , Grd As Boolean, Ln As Boolean)
	TxtCapcha  = Tx
	imgName = imNm
	Grid = Grd
	Lines = Ln
	makeCaptcha
End Sub

Private Sub makeCaptcha
	cv.Initialize("")
	cv.Width = wdt
	cv.Height = hgt
	cv.DrawRect(0, 0, wdt, hgt, fx.Colors.transparent, True, 0)
	If imgName <> "" Then
		Dim img As Image = fx.LoadImage(File.DirAssets, imgName)
		cv.DrawImage2(img, 0, 0, img.Width, img.Height, 0, 0, wdt, hgt)
	End If
	If Grid Then
		Dim fw As Double = wdt / 7
		Dim fh As Double = hgt / 5
		For x = 0 To  wdt Step fw
			cv.DrawLine(x, 0, x, hgt, fx.Colors.Red, 1)
		Next
		For y = 0 To hgt Step fh
			cv.DrawLine(0, y, wdt, Y, fx.Colors.Red, 1)
		Next
	End If
	If Lines Then
		For i = 1 To 12
			Dim t As Int = Rnd(1, wdt)
			Dim b As Int = Rnd(1, wdt)
			cv.DrawLine(t, 3, b, hgt - 3, fx.Colors.DarkGray, 0.7)
		Next
	End If
	Dim wh(2), sz As Int
	wh(0) = wdt
	sz = 20
	Do Until wh(0) < wdt - 10
		Dim f As Font = fx.CreateFont("Default", sz, True, False)
		'Dim wh() As Int = Main.MeasureTextWidth(TxtCapcha, f)'Utils.MeasureText(TxtCapcha, f)
		Dim wh() As Int = Utils.MeasureText(TxtCapcha, f)'Utils.MeasureText(TxtCapcha, f)
		sz = sz - 1
	Loop
	cv.DrawText(TxtCapcha, wdt / 2, hgt / 2 + 5, f, fx.Colors.Black, "CENTER")
	Dim imgR As Image = cv.Snapshot
	If SubExists(Main, "ResultO") Then
		CallSub2(Main, "ResultO", imgR)
	End If
	cv.DrawRect(0, 0, wdt, hgt, fx.Colors.Transparent, True, 0)
	Dim imgC As Image = DrawCaptch(imgR)
	cv.DrawImage(imgC, 0, 0, wdt, hgt)
	If SubExists(Main, "ResultC") Then
		CallSub2(Main, "ResultC", cv.Snapshot)
	End If
End Sub

Private Sub DrawCaptch(im As Image)  As Image
	Dim x, y As Int
	Dim mag0, per0 As Float
	Dim mag1, per1 As Float
	Dim mag2, per2 As Float
	Dim ix, iy As Int
	Dim dx0, dy0, dx1, dy1 As Float
	Dim r, g, b As Int
	Dim r00, g00, b00 As Int
	Dim r01, g01, b01 As Int
	Dim r10, g10, b10 As Int
	Dim r11, g11, b11 As Int
	Dim clr As Paint
	Dim rgb(4) As Int
	' Draw the source image.
	mag0 = Rnd(2, 6)
	per0 = Rnd(20, 30)
	mag1 = Rnd(3, 6)
	per1 = Rnd(20, 40)
	mag2 = Rnd(1, 3)
	per2 = Rnd(10, 20)
	Dim width As Int = wdt
	Dim height As Int = hgt
	' Make the destination bitmap.
	Dim ARGB As Int
	Dim InputJO, OutputJO, ReaderJO, WriterJO As JavaObject
	OutputJO.InitializeNewInstance("javafx.scene.image.WritableImage", Array As Object(width, height))
	InputJO = im
	ReaderJO = InputJO.RunMethod("getPixelReader",Null)
	WriterJO = OutputJO.RunMethod("getPixelWriter",Null)
	For x = 0 To width - 1
		For y = 0 To height - 1
			' Find source (x, y).
			Dim s As PointApi
			s = InvertXY(mag0, per0, mag1, per1, mag2, per2, x, y)
			' Interpolate.
			ix = s.x
			iy = s.y
			If ix < 0 Or ix >= width - 1 Or iy < 0 Or iy >= height - 1 Then
				ARGB = fx.Colors.To32Bit(fx.Colors.transparent)
				WriterJO.RunMethod("setArgb", Array As Object(x, y, ARGB))
			Else
				ARGB = ReaderJO.RunMethod("getArgb", Array As Object(ix, iy))
				rgb = Utils.getRGB(ARGB)
				r00 = rgb(1): g00 = rgb(2): b00 = rgb(3)
				ARGB = ReaderJO.RunMethod("getArgb", Array As Object(ix + 1, iy))
				rgb = Utils.getRGB(ARGB)
				r10 = rgb(1): g10 = rgb(2): b10 = rgb(3)
				ARGB = ReaderJO.RunMethod("getArgb", Array As Object(ix, iy + 1))
				rgb = Utils.getRGB(ARGB)
				r01 = rgb(1):g01 = rgb(2): b01 = rgb(3)
				ARGB = ReaderJO.RunMethod("getArgb", Array As Object(ix + 1, iy + 1))
				rgb = Utils.getRGB(ARGB)
				r11 = rgb(1): g11 = rgb(2): b11 = rgb(3)
				
				dx0 = s.x - ix
				dy0 = s.y - iy
				dx1 = 1 - dx0
				dy1 = 1 - dy0
				r = dy1 * (dx1 * r00 + dx0 * r10) + _
				dy0 * (dx1 * r01 + dx0 * r11)
				g = dy1 * (dx1 * g00 + dx0 * g10) + _
				dy0 * (dx1 * g01 + dx0 * g11)
				b = dy1 * (dx1 * b00 + dx0 * b10) + _
				dy0 * (dx1 * b01 + dx0 * b11)
				
				r = Max(Min(r, 255), 0)
				g = Max(Min(g, 255), 0)
				b = Max(Min(b, 255), 0)
				clr = fx.Colors.rgb(r, g, b)
				ARGB = fx.Colors.To32Bit(clr)
				WriterJO.RunMethod("setArgb", Array As Object(x, y, ARGB))
			End If
		Next
	Next
	Return OutputJO
End Sub

Private Sub InvertXY(mag0 As Float, per0 As Float, mag1 As Float, per1 As Float, mag2 As Float, per2 As Float, x As Int, y As Int) As PointApi
	Dim iv As PointApi
	iv.x = x - mag0 * Cos(y * cPI / per0)
	iv.y = y - mag1 * Sin(x * cPI / per1) - mag2 * Sin(x * cPI / per2)
	Return iv
End Sub